pidgin: cmds.h File Reference

pidgin 2.14.4

Loading...
Searching...
No Matches
Data Structures
cmds.h File Reference
libpurple

Commands API. More...

`#include "conversation.h"`

Go to the source code of this file.

## Data Structures
struct | PurpleCommandsUiOps
| Command UI operations; UIs should implement this if they want to handle commands themselves, rather than relying on the core. More...

## Functions
Commands API <br>
PurpleCmdId | purple_cmd_register (const gchar *cmd, const gchar *args, PurpleCmdPriority p, PurpleCmdFlag f, const gchar *prpl_id, PurpleCmdFunc func, const gchar *helpstr, void *data)
| Register a new command with the core.
void | purple_cmd_unregister (PurpleCmdId id)
| Unregister a command with the core.
PurpleCmdStatus | purple_cmd_do_command (PurpleConversation *conv, const gchar *cmdline, const gchar *markup, gchar **errormsg)
| Do a command.
gboolean | purple_cmd_execute (PurpleCmd *c, PurpleConversation *conv, const gchar *cmdline)
| Execute a specific command.
GList * | purple_cmd_list (PurpleConversation *conv)
| List registered commands.
GList * | purple_cmd_help (PurpleConversation *conv, const gchar *cmd)
| Get the help string for a command.
gpointer | purple_cmds_get_handle (void)
| Get the handle for the commands API.
void | purple_cmds_set_ui_ops (PurpleCommandsUiOps *ops)
| Sets the UI operations structure to be used when registering and unregistering commands.
PurpleCommandsUiOps * | purple_cmds_get_ui_ops (void)
| Returns the UI operations structure to be used when registering and unregistering commands.
void | purple_cmds_init (void)
| Initialize the commands subsystem.
void | purple_cmds_uninit (void)
| Uninitialize the commands subsystem.

## Structures <br>
#define | PURPLE_CMD_FUNC(func) ((PurpleCmdFunc)func)
enum | _PurpleCmdStatus { PURPLE_CMD_STATUS_OK , PURPLE_CMD_STATUS_FAILED , PURPLE_CMD_STATUS_NOT_FOUND , PURPLE_CMD_STATUS_WRONG_ARGS , PURPLE_CMD_STATUS_WRONG_PRPL , PURPLE_CMD_STATUS_WRONG_TYPE }
| The possible results of running a command with purple_cmd_do_command(). More...
enum | _PurpleCmdRet { PURPLE_CMD_RET_OK , PURPLE_CMD_RET_FAILED , PURPLE_CMD_RET_CONTINUE }
| Commands registered with the core return one of these values when run. More...
enum | _PurpleCmdPriority { PURPLE_CMD_P_VERY_LOW = -1000 , PURPLE_CMD_P_LOW = 0 , PURPLE_CMD_P_DEFAULT = 1000 , PURPLE_CMD_P_PRPL = 2000 , PURPLE_CMD_P_PLUGIN = 3000 , PURPLE_CMD_P_ALIAS = 4000 , PURPLE_CMD_P_HIGH = 5000 , PURPLE_CMD_P_VERY_HIGH = 6000 }
enum | _PurpleCmdFlag { PURPLE_CMD_FLAG_IM = 0x01 , PURPLE_CMD_FLAG_CHAT = 0x02 , PURPLE_CMD_FLAG_PRPL_ONLY = 0x04 , PURPLE_CMD_FLAG_ALLOW_WRONG_ARGS = 0x08 }
| Flags used to set various properties of commands. More...
typedef struct _PurpleCmd | PurpleCmd
typedef enum _PurpleCmdStatus | PurpleCmdStatus
| The possible results of running a command with purple_cmd_do_command().
typedef enum _PurpleCmdRet | PurpleCmdRet
| Commands registered with the core return one of these values when run.
typedef PurpleCmdRet(* | PurpleCmdFunc) (PurpleConversation *, const gchar *cmd, gchar **args, gchar **error, void *data)
| A function implementing a command, as passed to purple_cmd_register().
typedef guint | PurpleCmdId
| A unique integer representing a command registered with purple_cmd_register(), which can subsequently be passed to purple_cmd_unregister() to unregister that command.
typedef enum _PurpleCmdPriority | PurpleCmdPriority
typedef enum _PurpleCmdFlag | PurpleCmdFlag
| Flags used to set various properties of commands.

## Detailed Description

Commands API.

See also
  cmd-signals

Definition in file cmds.h.

## Macro Definition Documentation

## ◆ PURPLE_CMD_FUNC

#define PURPLE_CMD_FUNC | ( |  | func | ) | ((PurpleCmdFunc)func)

Definition at line 59 of file cmds.h.

## Typedef Documentation

## ◆ PurpleCmd

typedef struct _PurpleCmd PurpleCmd

Definition at line 34 of file cmds.h.

## ◆ PurpleCmdFlag

typedef enum _PurpleCmdFlag PurpleCmdFlag

Flags used to set various properties of commands.

Every command should have at least one of PURPLE_CMD_FLAG_IM and PURPLE_CMD_FLAG_CHAT set in order to be even slighly useful.

See also
  purple_cmd_register

## ◆ PurpleCmdFunc

typedef PurpleCmdRet(* PurpleCmdFunc) (PurpleConversation *, const gchar *cmd, gchar **args, gchar **error, void *data)

A function implementing a command, as passed to purple_cmd_register().

Todo:
  document the arguments to these functions.

Definition at line 65 of file cmds.h.

## ◆ PurpleCmdId

typedef guint PurpleCmdId

A unique integer representing a command registered with purple_cmd_register(), which can subsequently be passed to purple_cmd_unregister() to unregister that command.

Definition at line 71 of file cmds.h.

## ◆ PurpleCmdRet

typedef enum _PurpleCmdRet PurpleCmdRet

Commands registered with the core return one of these values when run.

Normally, a command will want to return one of the first two; in some unusual cases, you might want to have several functions called for a particular command; in this case, they should return PURPLE_CMD_RET_CONTINUE to cause the core to fall through to other commands with the same name.

## Enumeration Type Documentation

## ◆ _PurpleCmdFlag

enum _PurpleCmdFlag

Flags used to set various properties of commands.

Every command should have at least one of PURPLE_CMD_FLAG_IM and PURPLE_CMD_FLAG_CHAT set in order to be even slighly useful.

See also
  purple_cmd_register

Enumerator
PURPLE_CMD_FLAG_IM | Command is usable in IMs.
PURPLE_CMD_FLAG_CHAT | Command is usable in multi-user chats.
PURPLE_CMD_FLAG_PRPL_ONLY | Command is usable only for a particular prpl.
PURPLE_CMD_FLAG_ALLOW_WRONG_ARGS | Incorrect arguments to this command should be accepted anyway.

Definition at line 90 of file cmds.h.

## ◆ _PurpleCmdPriority

enum _PurpleCmdPriority

Definition at line 73 of file cmds.h.

## ◆ _PurpleCmdRet

enum _PurpleCmdRet

Commands registered with the core return one of these values when run.

Normally, a command will want to return one of the first two; in some unusual cases, you might want to have several functions called for a particular command; in this case, they should return PURPLE_CMD_RET_CONTINUE to cause the core to fall through to other commands with the same name.

Enumerator
PURPLE_CMD_RET_OK | Everything's okay; Don't look for another command to call.
PURPLE_CMD_RET_FAILED | The command failed, but stop looking.
PURPLE_CMD_RET_CONTINUE | Continue, looking for other commands with the same name to call.

Definition at line 53 of file cmds.h.

## ◆ _PurpleCmdStatus

enum _PurpleCmdStatus

The possible results of running a command with purple_cmd_do_command().

Definition at line 37 of file cmds.h.

## Function Documentation

## ◆ purple_cmd_do_command()

PurpleCmdStatus purple_cmd_do_command | ( | PurpleConversation * | conv,
|  | const gchar * | cmdline,
|  | const gchar * | markup,
|  | gchar ** | errormsg
| ) |  |

Do a command.

Normally the UI calls this to perform a command. This might also be useful if aliases are ever implemented.

Parameters

  conv | The conversation the command was typed in.
  cmdline | The command the user typed (including all arguments) as a single string. The caller doesn't have to do any parsing, except removing the command prefix, which the core has no knowledge of. cmd should not contain any formatting, and should be in plain text (no HTML entities).
  markup | This is the same as cmd, but is the formatted version. It should be in HTML, with < > and &, at least, escaped to HTML entities, and should include both the default formatting and any extra manual formatting.
  errormsg | If the command failed errormsg is filled in with the appropriate error message. It must be freed by the caller with g_free().

Returns
  A PurpleCmdStatus indicating if the command succeeded or failed.

## ◆ purple_cmd_execute()

gboolean purple_cmd_execute | ( | PurpleCmd * | c,
|  | PurpleConversation * | conv,
|  | const gchar * | cmdline
| ) |  |

Execute a specific command.

The UI calls this to execute a command, after parsing the command name.

Parameters

  c | The command to execute.
  conv | The conversation the command was typed in.
  cmdline | The command the user typed (only the arguments). The caller should remove the prefix and the command name. It should not contain any formatting, and should be in plain text (no HTML entities).

Returns
  TRUE if the command handled the cmdline, FALSE otherwise.

## ◆ purple_cmd_help()

GList * purple_cmd_help | ( | PurpleConversation * | conv,
|  | const gchar * | cmd
| ) |  |

Get the help string for a command.

Returns the help strings for a given command in the form of a GList, one node for each matching command.

Parameters

  conv | The conversation, or `NULL` for no context.
  cmd | The command. No wildcards accepted, but returns help for all commands if `NULL`.

Returns
  A `GList` of `const char *`s, which is the help string for that command.

## ◆ purple_cmd_list()

GList * purple_cmd_list | ( | PurpleConversation * | conv | ) |

List registered commands.

Returns a `GList` (which must be freed by the caller) of all commands that are valid in the context of conv, or all commands, if conv is `NULL`. Don't keep this list around past the main loop, or anything else that might unregister a command, as the `const char *`'s used get freed then.

Parameters

  conv | The conversation, or `NULL`.

Returns
  A `GList` of `const char *`, which must be freed with `g_list_free()`.

## ◆ purple_cmd_register()

PurpleCmdId purple_cmd_register | ( | const gchar * | cmd,
|  | const gchar * | args,
|  | PurpleCmdPriority | p,
|  | PurpleCmdFlag | f,
|  | const gchar * | prpl_id,
|  | PurpleCmdFunc | func,
|  | const gchar * | helpstr,
|  | void * | data
| ) |  |

Register a new command with the core.

The command will only happen if commands are enabled, which is a UI pref. UIs don't have to support commands at all.

Parameters

  cmd | The command. This should be a UTF-8 (or ASCII) string, with no spaces or other white space.
  args | A string of characters describing to libpurple how to parse this command's arguments. If what the user types doesn't match this pattern, libpurple will keep looking for another command, unless the flag PURPLE_CMD_FLAG_ALLOW_WRONG_ARGS is passed in f. This string should contain no whitespace, and use a single character for each argument. The recognized characters are: `'w'`: Matches a single word. `'W'`: Matches a single word, with formatting. `'s'`: Matches the rest of the arguments after this point, as a single string. `'S'`: Same as `'s'` but with formatting. If args is the empty string, then the command accepts no arguments. The args passed to the callback func will be a `NULL` terminated array of `NULL` terminated strings, and will always match the number of arguments asked for, unless PURPLE_CMD_FLAG_ALLOW_WRONG_ARGS is passed.
  p | This is the priority. Higher priority commands will be run first, and usually the first command will stop any others from being called.
  f | Flags specifying various options about this command, combined with `|` (bitwise OR). You need to at least pass one of PURPLE_CMD_FLAG_IM or PURPLE_CMD_FLAG_CHAT (you may pass both) in order for the command to ever actually be called.
  prpl_id | If the PURPLE_CMD_FLAG_PRPL_ONLY flag is set, this is the id of the prpl to which the command applies (such as `"prpl-aim"`). If the flag is not set, this parameter is ignored; pass `NULL` (or a humourous string of your choice!).
  func | This is the function to call when someone enters this command.
  helpstr | a whitespace sensitive, UTF-8, HTML string describing how to use the command. The preferred format of this string is the command's name, followed by a space and any arguments it accepts (if it takes any arguments, otherwise no space), followed by a colon, two spaces, and a description of the command in sentence form. Do not include a slash before the command name.
  data | User defined data to pass to the PurpleCmdFunc f.

Returns
  A PurpleCmdId, which is only used for calling purple_cmd_unregister, or 0 on failure.

## ◆ purple_cmd_unregister()

void purple_cmd_unregister | ( | PurpleCmdId | id | ) |

Unregister a command with the core.

All registered commands must be unregistered, if they're registered by a plugin or something else that might go away. Normally this is called when the plugin unloads itself.

Parameters

  id | The PurpleCmdId to unregister, as returned by purple_cmd_register.

## ◆ purple_cmds_get_handle()

gpointer purple_cmds_get_handle | ( | void |  | ) |

Get the handle for the commands API.

Returns
  The handle

Since
  2.5.0

## ◆ purple_cmds_get_ui_ops()

PurpleCommandsUiOps * purple_cmds_get_ui_ops | ( | void |  | ) |

Returns the UI operations structure to be used when registering and unregistering commands.

Returns
  The UI operations structure.

## ◆ purple_cmds_init()

void purple_cmds_init | ( | void |  | ) |

Initialize the commands subsystem.

Since
  2.5.0

## ◆ purple_cmds_set_ui_ops()

void purple_cmds_set_ui_ops | ( | PurpleCommandsUiOps * | ops | ) |

Sets the UI operations structure to be used when registering and unregistering commands.

The UI operations need only be set if the UI wants to handle the commands itself; otherwise, leave it as NULL.

Parameters

  ops | The UI operations structure.

## ◆ purple_cmds_uninit()

void purple_cmds_uninit | ( | void |  | ) |

Uninitialize the commands subsystem.

Since
  2.5.0